/** @file
 * @brief The abstract IPService interface. This class represents all IP services.
 *
 *
 *
 * @copyright Intra2net AG
 * @license GPLv2
*/

#ifndef IPSERVICE_H
#define IPSERVICE_H

#include <string>

#include <boost/shared_ptr.hpp>


class IPService
{

public:

    typedef boost::shared_ptr<IPService> Ptr;

    virtual ~IPService() {};

    virtual int connect(const std::string& _hostname, const std::string& _port) = 0;

    virtual std::string read_from_socket() = 0;

    virtual int write_to_socket(const std::string& data) = 0;

    virtual int close() = 0;
};

#endif
